=== client/CMakeLists.txt ===
PROJECT(ACNG CXX C)

ADD_EXECUTABLE(in.acng client.cc)
SET_TARGET_PROPERTIES(in.acng PROPERTIES COMPILE_FLAGS "${ACNG_CXXFLAGS_COMMON} -DMINIBUILD")
TARGET_LINK_LIBRARIES(in.acng ${NetworkLibs} ${EXTRA_LIBS_INETD})
INSTALL(TARGETS in.acng DESTINATION ${LIBDIR})
