=== debian/changelog ===
apt-cacher-ng (0.9.1-1~bpo7+1) wheezy-backports-sloppy; urgency=low

  * Update from Testing

 -- Eduard Bloch <blade@debian.org>  Wed, 16 Mar 2016 20:25:25 +0100

apt-cacher-ng (0.9.1-1) unstable; urgency=low

  * New upstream version

 -- Eduard Bloch <blade@debian.org>  Sun, 28 Feb 2016 17:20:41 +0100

apt-cacher-ng (0.9.0-1) experimental; urgency=low

  * New upstream version

 -- Eduard Bloch <blade@debian.org>  Mon, 01 Feb 2016 19:50:49 +0100

apt-cacher-ng (0.8.9-1) unstable; urgency=medium

  * New upstream version (avoids use of Proxy in cron jobs, closes: #811350)

 -- Eduard Bloch <blade@debian.org>  Thu, 21 Jan 2016 20:24:39 +0100

apt-cacher-ng (0.8.3-1~bpo7+1) wheezy-backports-sloppy; urgency=low

  * Targeting sloppy distribution and changed version following the new rules

 -- Eduard Bloch <blade@debian.org>  Thu, 14 May 2015 11:01:39 +0200

apt-cacher-ng (0.8.3-1~bpo70+1) wheezy-backports; urgency=low

  * Minor version update for oldstable-backports

 -- Eduard Bloch <blade@debian.org>  Sun, 10 May 2015 17:04:04 +0200
