## apt-cacher-ng 0.9.3.2

=== CMakeLists.txt ===
--- 
+++ 
@@ -77,7 +77,7 @@
 # also influence it, need to be adjusted carefully by user.
 SET(ACNG_CXXFLAGS_COMMON "-D_FILE_OFFSET_BITS=64")
 
-foreach(cxxarg  -pthread -Wall -Wextra -Wno-unused-parameter -fvisibility-inlines-hidden)
+foreach(cxxarg  -pthread -Wall -Wextra -Wno-unused-parameter -fvisibility-inlines-hidden -fvisibility=hidden)
 	STRING(REGEX REPLACE "=|-|," "" optname "${cxxarg}")
   CHECK_CXX_COMPILER_FLAG("${cxxarg}" "CXX_${optname}")
   if(CXX_${optname})
@@ -85,7 +85,7 @@
 	endif()
 endforeach()
 
-foreach(linkarg -Wl,--as-needed -Wl,-O1 -Wl,--discard-all -Wl,--no-undefined -Wl,--build-id=sha1)
+foreach(linkarg -Wl,--as-needed -Wl,-O1 -Wl,--discard-all -Wl,--no-undefined -Wl,--build-id=sha1 -Wl,-fuse-ld=gold -Wl,--threads)
 	STRING(REGEX REPLACE "=|-|," "" optname "${linkarg}")
 	set(CMAKE_REQUIRED_FLAGS "${linkarg}")
 	CHECK_CXX_COMPILER_FLAG("" "LD_${optname}")
@@ -96,21 +96,22 @@
 endforeach(linkarg)
 
 option(USE_SSL "Use OpenSSL library for TLS and other crypto functionality" on)
-# option(USE_LTO "Enable Link Time Optimization (requires modern compilers)" on)
 
 IF(CMAKE_SYSTEM MATCHES "Darwin")
    SET(ACNG_CXXFLAGS_COMMON " ${ACNG_CXXFLAGS_COMMON} -D_DARWIN_C_SOURCE ")
 ENDIF(CMAKE_SYSTEM MATCHES "Darwin")
 
 IF(CMAKE_SYSTEM MATCHES "CYGWIN")
-	set(USE_LTO off)
+	set(USE_LTO_DEFAULT off)
 	SET(ACNG_CXXFLAGS_COMMON " ${ACNG_CXXFLAGS_COMMON}  -U__STRICT_ANSI__ -DNOMINMAX ")
 ELSE()
-
+  if(CMAKE_COMPILER_IS_GNUCXX AND CMAKE_CXX_COMPILER_VERSION MATCHES "^[56789]")
+     set(USE_LTO_DEFAULT on)
+  endif()
 ENDIF()
 
 if(CMAKE_BUILD_TYPE MATCHES Debug)
-   set(USE_LTO off)
+   set(USE_LTO_DEFAULT off)
    set(ACNG_CXXFLAGS_COMMON "-DDEBUG ${ACNG_CXXFLAGS_COMMON}")
 else()
    set(CMAKE_REQUIRED_FLAGS "-Wl,--gc-sections")
@@ -123,28 +124,37 @@
 endif()
 
 FILE(READ test/build/testcxx11.cc CXX11_TESTSRC)
-# prefer that style if possible since since Cygwin seems to have an old bug with missing definitions, http://cygwin.com/ml/cygwin/2012-04/msg00140.html
-CHECK_CXX_COMPILER_FLAG(-std=gnu++11 COMPILER_SUPPORTS_GNU11)
-if(COMPILER_SUPPORTS_GNU11)
-	set(ACNG_CXXFLAGS_COMMON "${ACNG_CXXFLAGS_COMMON} -std=gnu++11")
-else()
-	CHECK_CXX_COMPILER_FLAG(-std=c++11 COMPILER_SUPPORTS_CXX11)
-	if(COMPILER_SUPPORTS_CXX11)
-		set(ACNG_CXXFLAGS_COMMON "${ACNG_CXXFLAGS_COMMON} -std=c++11")
-	else()
-		CHECK_CXX_COMPILER_FLAG(-std=c++0x COMPILER_SUPPORTS_CXX0X)
-		if(COMPILER_SUPPORTS_CXX0X)
-			set(ACNG_CXXFLAGS_COMMON "${ACNG_CXXFLAGS_COMMON} -std=c++0x")
-		else()
-			message(FATAL_ERROR "!! Error: failed to configure compiler for C++11 support. For GCC, version 4.7 or newer is required.")
-		endif()
-	endif()
-endif()
+CHECK_CXX_SOURCE_COMPILES("${CXX11_TESTSRC}" COMPILER_SUPPORTS_DEFAULT_CXX11)
+if(NOT COMPILER_SUPPORTS_DEFAULT_CXX11)
+   # prefer that style if possible since since Cygwin seems to have an old bug with missing definitions, http://cygwin.com/ml/cygwin/2012-04/msg00140.html
+   CHECK_CXX_COMPILER_FLAG(-std=gnu++11 COMPILER_SUPPORTS_GNU11)
+   if(COMPILER_SUPPORTS_GNU11)
+      set(ACNG_CXXFLAGS_COMMON "${ACNG_CXXFLAGS_COMMON} -std=gnu++11")
+   else()
+      CHECK_CXX_COMPILER_FLAG(-std=c++11 COMPILER_SUPPORTS_CXX11)
+      if(COMPILER_SUPPORTS_CXX11)
+         set(ACNG_CXXFLAGS_COMMON "${ACNG_CXXFLAGS_COMMON} -std=c++11")
+      else()
+         CHECK_CXX_COMPILER_FLAG(-std=c++0x COMPILER_SUPPORTS_CXX0X)
+         if(COMPILER_SUPPORTS_CXX0X)
+            set(ACNG_CXXFLAGS_COMMON "${ACNG_CXXFLAGS_COMMON} -std=c++0x")
+         else()
+            message(FATAL_ERROR "!! Error: failed to configure compiler for C++11 support. For GCC, version 4.7 or newer is required.")
+         endif()
+      endif()
+   endif()
+endif()
+
+# XXX: make this stuff not be printed later?
+#if(NOT DEFINED(USE_LTO))
+message("-- LTO default choice for this toolchain is: ${USE_LTO_DEFAULT}")
+#endif()
+option(USE_LTO "Enable Link Time Optimization (requires modern compilers)" ${USE_LTO_DEFAULT})
 
 if(USE_LTO)
    SET(LDFLAGS_NOLTO "${CMAKE_EXE_LINKER_FLAGS}")
-   SET(CMAKE_REQUIRED_FLAGS "${ACNG_CXXFLAGS_COMMON} -flto -flto-partition=none")
-   SET(CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} -flto -flto-partition=none")
+   SET(CMAKE_REQUIRED_FLAGS "${ACNG_CXXFLAGS_COMMON} -flto")
+   SET(CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} -flto")
    CHECK_CXX_SOURCE_COMPILES("${CXX11_TESTSRC}" HAS_LTO)
    if(HAS_LTO)
       SET(ACNG_CXXFLAGS_COMMON ${CMAKE_REQUIRED_FLAGS})
@@ -154,6 +164,7 @@
       message(WARNING "Link Time Optimization support broken, disabling it.")
    endif()
 endif()
+message("-- LTO final setting is: ${USE_LTO}")
 
 FIND_LIBRARY(HAVE_SOCKETLIB socket) # separate socket lib looks like Solaris-like environment
 if(HAVE_SOCKETLIB)
@@ -329,25 +340,3 @@
 # all checks done, save configuration #
 #######################################
 
-CONFIGURE_FILE("${CMAKE_SOURCE_DIR}/include/acsyscap.h.in" "${CMAKE_BINARY_DIR}/acsyscap.h")
-
-add_subdirectory(client)
-add_subdirectory(fs)
-add_subdirectory(source)
-add_subdirectory(conf)
-add_subdirectory(systemd)
-
-###
-### Extra install rules for static files
-###
-if(NOT DEFINED(HTMLDIR))
-		set(HTMLDIR ${DOCDIR}/html)
-endif()
-if(NOT DEFINED(MANDIR))
-   set(MANDIR ${DATADIR}/man)
-endif()
-install(FILES doc/README doc/apt-cacher-ng.pdf DESTINATION ${DOCDIR})
-install(DIRECTORY doc/html/ DESTINATION ${HTMLDIR}
-   FILES_MATCHING PATTERN "*.*")
-install(DIRECTORY doc/man/ DESTINATION ${MANDIR}/man8
-   FILES_MATCHING PATTERN "*.8")
