=== debian/changelog ===
apt-cacher-ng (0.9.3.2-1) unstable; urgency=low

  * New upstream version
    + Fix FTBFS with non-Linux kernels (closes: #830736)
  * Better sanity check of data retrieved when looking for Ubuntu mirrors and
    correct checking of curl return code (prevents accidental inclusion of
    garbage from error messages of intermediate proxies into backend mirror
    configuration). Also sets shorter timeouts when fetching mirrors.txt
    (which closes: #827721 even while upgrading from very old versions)
  * In postinst, dropped some "smart" code which was trying to setup the
    default cache directory in case when clueless user deleted the related
    configuration line. That guessing was probably helping less often than it
    might have broken things; it contained a bug which (only on the very first
    installation) could incorrectly add a forced setting of CacheDir
    (closes: #830578)
  * Giving the question about pass-through higher debconf priority since some
    people seem to care a lot about HTTPS forwarding (#813359)

 -- Eduard Bloch <blade@debian.org>  Tue, 12 Jul 2016 22:03:27 +0200

apt-cacher-ng (0.9.3.1-1) unstable; urgency=low

  * New upstream version
  * Sync with standards 0.9.8
  * Not stopping daemon on upgrade (closes: #825154)

 -- Eduard Bloch <blade@debian.org>  Wed, 08 Jun 2016 23:34:30 +0200

apt-cacher-ng (0.9.3-1) unstable; urgency=medium

  * New upstream version
    + handling for removal of SHA1 signature lists in recent Release/InRelease
      files (closes: #824293)
    + better support of by-hash storage (now really closes: #819852 apart from
      some corner cases)
    + better links in error reporting mails (closes: #825640)

 -- Eduard Bloch <blade@debian.org>  Sun, 29 May 2016 18:30:24 +0200

apt-cacher-ng (0.9.2-1) unstable; urgency=low

  * New upstream version
    + basic support for by-hash index files (closes: #819852) including some
      precaution in cache cleanup routines
    + supports .asc signatures for source (closes: #823733)
    + supports repo names with hyphens again (closes: #823570)
    + supports deb.debian.org by default (closes: #820813)
  * Japanese Debconf template update from Takuma Yamada included
    (closes: #815527)

 -- Eduard Bloch <blade@debian.org>  Fri, 13 May 2016 20:04:32 +0200
