=== debian/rules ===
--- 
+++ 
@@ -10,13 +10,9 @@
 # https://wiki.debian.org/Hardening#Notes_for_packages_using_CMake
 CFLAGS += $(CPPFLAGS)
 CXXFLAGS += $(CPPFLAGS)
-export CC=gcc-4.7
-export CXX=g++-4.7
-export CPP=cpp-4.7
-export CMAKEOPTS=--debug-trycompile
 
 %:
-	dh $@ --parallel
+	dh $@ --parallel --with systemd
 
 override_dh_auto_configure:
 	dh_auto_configure -- -DSDINSTALL=on
@@ -34,7 +30,7 @@
 	test -r debian/apt-cacher-ng/etc/apt-cacher-ng/backends_ubuntu.default || mv debian/apt-cacher-ng/usr/lib/apt-cacher-ng/backends_ubuntu.default debian/apt-cacher-ng/etc/apt-cacher-ng/
 
 override_dh_installinit:
-	dh_installinit -- defaults 18
+	dh_installinit --no-restart-on-upgrade --restart-after-upgrade -- defaults 18
 
 override_dh_compress:
 	dh_compress -X.pdf
