## apt-cacher-ng 2

=== CMakeLists.txt ===
--- 
+++ 
@@ -171,6 +171,12 @@
    LIST(APPEND BaseNetworkLibs socket nsl)
 endif(HAVE_SOCKETLIB)
 
+FIND_LIBRARY(HAVE_ATOMICLIB atomic) # needed for global atomic vars on some 32bit architectures
+if(HAVE_ATOMICLIB)
+        MESSAGE("-- Found libatomic development files, will link libatomic")
+        LIST(APPEND BaseNetworkLibs atomic)
+endif()
+
 # explicit linking needed for global locks in dlcon
 list(APPEND BaseNetworkLibs pthread)
 
@@ -333,10 +339,3 @@
 SET(CMAKE_REQUIRED_FLAGS ${ACNG_CXXFLAGS_COMMON})
 
 # I don't need -rdynamic, thanks!
-SET(CMAKE_SHARED_LIBRARY_LINK_CXX_FLAGS "")
-SET(CMAKE_SHARED_LIBRARY_LINK_C_FLAGS "")
-
-#######################################
-# all checks done, save configuration #
-#######################################
-
