=== debian/changelog ===
apt-cacher-ng (2-2) testing; urgency=high

  * Special version only for Debian Stretch, solving moderate security issues:
    + hardening against HTTP header splitting attack (no user input printed in
      the HTTP headers anymore; backport from Sid, related to CVE-2017-7443)
    + hardening against unintended or malicious triggering of hidden space
      allocation, by disabling the fallocate completely. This is ultima ratio,
      trading code simplicity for fragmentation avoiding efforts; a smarter
      solution is found in upstream version 3; closes: #856635)
    + handle a corner case of bad TLS handshake with invalid certificate
      (related to #839751)

 -- Eduard Bloch <blade@debian.org>  Thu, 13 Apr 2017 18:11:17 +0200

apt-cacher-ng (2-1) unstable; urgency=low

  * New upstream version
    + Fix for incorrect compilation with gcc-5.4 (closes: #843417, #843410)
    + Fixes communication of cron job runner on systems where public address
      was guessed incorrectly and/or connection was not possible
      (closes: #843834, #841633)
    + Fix ExStartTradeOff computation with unit suffix (closes: #845245)
    + Linking libatomic where possible (closes: #841431, now really)
  * Not rotating apt-cacher.err log when file is empty (notifempty option,
    closes: #832882)

 -- Eduard Bloch <blade@debian.org>  Tue, 22 Nov 2016 21:39:43 +0100

apt-cacher-ng (1-2) unstable; urgency=low

  [ Dejan Latinovic <Dejan.Latinovic@imgtec.com> ]
  * Fixing FTBFS on MIPS (extra libatomic dependency, closes: #841431)

  [Eduard Bloch]
  * Extended mips/mipsel FTBFS patch to powerpcspe and m68k

 -- Eduard Bloch <blade@debian.org>  Thu, 20 Oct 2016 20:25:39 +0200

apt-cacher-ng (1-1) unstable; urgency=low

  * New upstream version
    + Better TLS hostname checks (closes: #839751)
    + Making build reproducible again (closes: #834755)

 -- Eduard Bloch <blade@debian.org>  Wed, 19 Oct 2016 22:14:15 +0200
